﻿Type=StaticCode
Version=7.01
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim Sound As SoundPool
	Dim ticksnd(5) As Int
	Public Const FILTER_BITMAP_FLAG As Int = 2

End Sub

Public Sub Sound_Init
	Sound.Initialize(3)
	ticksnd(0) = Sound.Load(File.DirAssets,"Click2.mp3")
	ticksnd(1) = Sound.Load(File.DirAssets, "beep-21.mp3")
	ticksnd(2) = Sound.Load(File.DirAssets, "button-15.mp3")
	ticksnd(3) = Sound.Load(File.DirAssets,"fireworks01.mp3")
	ticksnd(4) = Sound.Load(File.DirAssets, "fireworks02.mp3")
	
End Sub

Public Sub SoundPlay(tk As Short)
	Sound.Play(ticksnd(tk), 1, 1, 5, 0, 0)
End Sub

Public Sub ButtonSetStateListDrawable(btnBitmap As Button, EnabledBitmap As String, PressedBitmap As String, DisabledBitmap As String)
    ' Define a bitmap for Enabled state
    Dim bdwEnabled As BitmapDrawable
    bdwEnabled.Initialize(LoadBitmap(File.DirAssets, EnabledBitmap))
  
    ' Define a bitmap for Pressed state
    Dim bdwPressed As BitmapDrawable
    bdwPressed.Initialize(LoadBitmap(File.DirAssets, PressedBitmap))

    ' Define a bitmap for Disabled state
    Dim bdwDisabled As BitmapDrawable
    bdwDisabled.Initialize(LoadBitmap(File.DirAssets, DisabledBitmap))

    ' Define a StateListDrawable
    Dim stdBitmap As StateListDrawable
    stdBitmap.Initialize
    Dim states(2) As Int
    states(0) = stdBitmap.state_enabled
    states(1) = -stdBitmap.state_pressed
    stdBitmap.addState2(states, bdwEnabled)
    Dim states(1) As Int
    states(0) = stdBitmap.state_enabled
    stdBitmap.addState2(states, bdwPressed)
    Dim states(1) As Int
    states(0) = stdBitmap.State_Disabled
    stdBitmap.addState2(states, bdwDisabled)

    ' Set stdBitmap to button btnBitmap
	btnBitmap.Background = stdBitmap
End Sub

Sub SetAntiAlias (c As Canvas, FilterFlag As Int)
	Dim r As Reflector
	Dim NativeCanvas As Object
	r.Target = c
	NativeCanvas = r.GetField("canvas")
	Dim PaintFlagsDrawFilter As Object
	PaintFlagsDrawFilter = r.CreateObject2("android.graphics.PaintFlagsDrawFilter", _
      Array As Object(0, FilterFlag), Array As String("java.lang.int", "java.lang.int"))
	r.Target = NativeCanvas
	r.RunMethod4("setDrawFilter", Array As Object(PaintFlagsDrawFilter), Array As String("android.graphics.DrawFilter"))
End Sub

Public Sub RotateViewXY(v As View, Degrees As Float, x As Float, y As Float)
   	Dim jo As JavaObject = v
	jo.RunMethod("setPivotX", Array(x))
	jo.RunMethod("setPivotY", Array(y))
	jo.RunMethod("setRotation", Array(Degrees))	
End Sub

Public Sub RotateViewY(v As View, Degrees As Float, x As Float, y As Float)
   	Dim jo As JavaObject = v
	jo.RunMethod("setPivotX", Array(x))
	jo.RunMethod("setPivotY", Array(y))
	jo.RunMethod("setRotationY", Array(Degrees))	
End Sub