﻿Type=Class
Version=7.01
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@

Sub Class_Globals
	Type Part(X As Float, Y As Float, Xv As Float, Yv As Float, life As Short, Dead As Boolean)
	Type tEffect(X As Float, Y As Float, Alpha As Int, P As List)
	Private FW As tEffect
	Private Timer As Timer
	Private CallBack As Object
	Private fIdx As Short = -1
	Private crdBmp() As ImageView
End Sub

Public Sub Initialize(CallbackModule As Object, xP As Int, yP As Int, Crds() As ImageView)
	CallBack = CallbackModule
	crdBmp = Crds
    Timer.Initialize("Timer", 16)
	Timer.Enabled = False
	FW.Initialize
	FW.X = xP
	FW.Y = yP
	FW.P.Initialize
	InitEffect
	CallSubDelayed(Me, "starTimer")
End Sub

Private Sub starTimer
	Timer.Enabled = True
End Sub

Private Sub DrawFireWork(idx As Short)
    Dim DeadCount As Short
	Dim szP As Int  = FW.P.Size
	For i = 0 To szP - 1
		Dim nFW As Part = FW.P.Get(i)
		If nFW.Life > -40 Then
			nFW.Life = nFW.Life - 1
			nFW.X = nFW.X + nFW.Xv
			nFW.Y = nFW.Y + nFW.Yv
			nFW.Xv = nFW.Xv / 1.05
			nFW.Yv = nFW.Yv / 1.05 + 0.05
			crdBmp(i).Left = nFW.X
			crdBmp(i).Top = nFW.Y
		Else
			nFW.Dead = True
			DeadCount = DeadCount + 1
		End If
	Next
	If DeadCount > FW.P.Size -1 Then
		Timer.Enabled = False
		CallSub(CallBack, "enableButtons")
	End If

End Sub

Private Sub InitEffect
	Dim Shape As Short
    Dim RndSpeed As Float
    Dim RndDeg As Float
	Shape = Rnd(0, 2)
	Select Case Shape
		Case 0 'Regular
			For i = 0 To 20
				Dim nFW As Part
				nFW.X = FW.X
				nFW.Y = FW.Y
				nFW.Life = 80
				RndSpeed = Rnd(0,  6)
				RndDeg = Rnd(0, 360) / 57.3
				nFW.Xv = RndSpeed * Cos(RndDeg)
				nFW.Yv = RndSpeed * Sin(RndDeg)
				FW.P.Add(nFW)
			Next
		Case 1 'Spiral
			RndDeg = Rnd(0, 360)
			For i = 0 To 20
				Dim nFW As Part
				nFW.X = FW.X
				nFW.Y = FW.Y
				nFW.Life = 80
				nFW.Xv = (i * 0.5) * Cos(((360 / 25) * (i + 1) + RndDeg) / 57.3)
				nFW.Yv = (i * 0.3) * Sin(((360 / 25) * (i + 1) + RndDeg) / 57.3)
				FW.P.Add(nFW)
			Next
	End Select
End Sub

Private Sub Timer_Tick
	DrawFireWork(fIdx) 

End Sub

Public Sub Stop
	Timer.Enabled = False
End Sub

