﻿Type=Class
Version=7.01
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
Sub Class_Globals
	Private imgToTurn As ImageView
	Private timer As Timer
	Private imgWdt, imgHgt As Int 
	Private Bmp As Bitmap
	Private BmpFront As Bitmap
	Private BmpBack As Bitmap
	Private cBack As String
	Private Parent As Object
	Private Degrees	As Short
	Private Increase As Short
	Private imgIdx As Short
End Sub

'Dim Turn as cTurn
'Turn initialize(Me)
Public Sub Initialize(prt As Object)
	Parent = prt
	Bmp.Initialize(File.DirAssets, "Cards01.png")
	timer.Initialize("timer",8)
	timer.Enabled = False
End Sub

Public Sub Img_to_Turn(imgV As ImageView, idx As Short, toBack As Boolean, mSub As String)
	imgIdx = idx
	imgToTurn = imgV
	cBack = mSub
	imgHgt = imgToTurn.Height
	imgWdt = imgToTurn.Width
	Dim BmpFront As Bitmap
	Dim BmpBack As Bitmap
	If toBack Then
		BmpFront = DrawImage(imgIdx , False)
		BmpBack = DrawImage(55, True)
		Increase = 9
	Else
		BmpBack = DrawImage(imgIdx, True)
		BmpFront = DrawImage(55, False)
		Increase = -9
	End If
	imgToTurn.Bitmap = BmpFront
	Degrees = 0
	timer.Enabled = True
End Sub

private Sub Turn_Card
	If Abs(Degrees) > = 90 Then
		imgToTurn.Bitmap = BmpBack	
	End If
	Utils.RotateViewY(imgToTurn, Degrees, imgToTurn.Width * .5, imgToTurn.Height * .5)
	If Abs(Degrees) > = 180  Then
		timer.Enabled = False
		Degrees = 0.0
		Utils.RotateViewY(imgToTurn, Degrees, imgToTurn.Width * .5, imgToTurn.Height * .5)		
		If Increase > 0 Then
			BmpBack = DrawImage(55 , False)
		Else
			BmpBack = DrawImage(imgIdx , False)
		End If
		imgToTurn.Bitmap = BmpBack 
		If cBack <> "*" Then CallSubDelayed(Parent, cBack)
	End If		
End Sub


Private Sub DrawImage(cValue As Short, Flipped As Boolean ) As Bitmap
	Dim cv As Canvas
	Dim BM As Bitmap
	Dim sTmp As Short
	Dim rtSrc As Rect
	Dim rtDst As Rect
	BM.InitializeMutable(imgWdt,imgHgt)
	cv.Initialize2(BM)
	
	#If WithAntiAliasing
		Utils.SetAntiAlias(cv, Utils.FILTER_BITMAP_FLAG)
	#End If
	
	sTmp = cValue Mod 13
	If sTmp = 0 Then sTmp = 13
	Dim cl As Short = 71 * (sTmp-1)
	Dim rw As Short  = (cValue-sTmp)/13
	rw = rw * 96
	rtSrc.Initialize(cl, rw, cl + 71, rw + 96)
	rtDst.Initialize(0, 0, imgWdt, imgHgt)
	If Flipped Then
		cv.DrawBitmapFlipped(Bmp, rtSrc, rtDst, False, True)
	Else
		cv.DrawBitmap(Bmp, rtSrc, rtDst)
	End If
	Return BM
End Sub

Private Sub timer_tick
	Degrees = Degrees + Increase
	Turn_Card
End Sub
